<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'WordCloud',
  props: {
    data: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
  },
});
</script>

<template>
  <div ref="path" class="path">
    <div class="cloud">
      <div v-for="item in data" :key="item">
        <span>{{ item }}</span>
      </div>
      <div class="orbs">
        <span></span><span></span><span></span><span></span><span></span
        ><span></span><span></span>
      </div>
    </div>
    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 1031 262">
      <path stroke="url(#paint0_linear_574_13652)" d="M303 59.336h474" />
      <path
        stroke="url(#paint1_linear_574_13652)"
        d="M428 59.336h49.893c4.595 0 8.316-2.266 8.316-5.063v-41.14c0-2.1 2.786-3.797 6.236-3.797H876"
      />
      <path
        stroke="url(#paint2_linear_574_13652)"
        d="M-1 59.336h336.687c4.593 0 8.313 2.29 8.313 5.119v99.416c0 2.713-1.746 5.324-4.863 7.243l-63.721 39.222"
      />
      <path
        stroke="url(#paint3_linear_574_13652)"
        d="M344 156.336h216.107c1.482 0 2.936.412 4.198 1.19l77.249 47.62a8.001 8.001 0 0 0 4.198 1.19H1022"
      />
      <path stroke="url(#paint4_linear_574_13652)" d="M539 156.336h185" />
      <path
        stroke="url(#paint5_linear_574_13652)"
        d="M0 174.336h179.105a8 8 0 0 1 8 8v63a8 8 0 0 0 8 8H790"
      />
      <path stroke="url(#paint6_linear_574_13652)" d="M170 174.336h94" />
      <defs>
        <linearGradient
          id="paint0_linear_574_13652"
          x1="303"
          x2="673.053"
          y1="59.836"
          y2="59.836"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#3825FF" />
          <stop offset="1" stop-color="#CA4EFB" />
        </linearGradient>
        <linearGradient
          id="paint1_linear_574_13652"
          x1="428"
          x2="543.378"
          y1="34.336"
          y2="34.336"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#3825FF" />
          <stop offset="1" stop-color="#CA4EFB" />
        </linearGradient>
        <linearGradient
          id="paint2_linear_574_13652"
          x1="236.447"
          x2="352.725"
          y1="145.188"
          y2="76.442"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#CA4EFB" />
          <stop offset="1" stop-color="#3825FF" />
        </linearGradient>
        <linearGradient
          id="paint3_linear_574_13652"
          x1="463.586"
          x2="694.031"
          y1="153.772"
          y2="274.975"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#5F30FE" />
          <stop offset="1" stop-color="#3825FF" />
        </linearGradient>
        <linearGradient
          id="paint4_linear_574_13652"
          x1="725.039"
          x2="540.039"
          y1="156.836"
          y2="156.836"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#BC4BFC" />
          <stop offset="1" stop-color="#3825FF" />
        </linearGradient>
        <linearGradient
          id="paint5_linear_574_13652"
          x1="908.377"
          x2="5.075"
          y1="213.843"
          y2="213.843"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#3825FF" />
          <stop offset="1" stop-color="#BC4BFC" />
        </linearGradient>
        <linearGradient
          id="paint6_linear_574_13652"
          x1="278.085"
          x2="170.604"
          y1="174.836"
          y2="174.836"
          gradientUnits="userSpaceOnUse"
        >
          <stop stop-color="#3825FF" />
          <stop offset="1" stop-color="#BC4BFC" />
        </linearGradient>
      </defs>
    </svg>
  </div>
</template>

<style lang="scss" scoped>
.path {
  position: relative;
  svg {
    width: 130%;
    margin-left: -10%;
    @media (min-width: $breakpoint-md) {
      width: 100%;
      margin-left: 0%;
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
    }
  }

  .cloud {
    position: absolute;
    width: 100%;
    height: 100%;
    left: 0;
    right: 0;
    display: flex;
    flex-wrap: wrap;
    font-family: 'GitLab Mono';
    bottom: 0;
    line-height: 1;
    & > :nth-child(1) {
      flex: 1 0 47%;
      justify-content: right;
      display: flex;
      align-items: center;
      height: 22%;
      font-size: 13px;
      @media (min-width: $breakpoint-sm) {
        padding-right: 32px;
        font-size: 20px;
        flex: 1 0 47%;
      }
      @media (min-width: $breakpoint-lg) {
        font-size: 26px;
      }
    }
    & > :nth-child(2) {
      flex: 1 0 51%;
      display: flex;
      align-items: center;
      height: 22%;
      font-size: 13px;
      padding-left: 20px;
      @media (min-width: $breakpoint-sm) {
        flex: 1 0 40%;
        padding-top: 8px;
        font-size: 20px;
        padding-left: 0;
      }
      @media (min-width: $breakpoint-md) {
        padding-left: 32px;
        flex: 1 0 50%;
      }
    }
    & > :nth-child(3) {
      flex: 1 0 20%;
      height: 35%;
      display: flex;
      align-items: center;
      font-size: 13px;
      @media (min-width: $breakpoint-sm) {
        padding-top: 20px;
        margin-left: 32px;
        font-size: 20px;
      }
      @media (min-width: $breakpoint-lg) {
        font-size: 32px;
      }
    }
    & > :nth-child(4) {
      flex: 1 0 56%;
      height: 35%;
      margin-left: 32px;
      display: flex;
      align-items: center;
      font-size: 13px;
      @media (min-width: $breakpoint-sm) {
        font-size: 20px;
      }
      @media (min-width: $breakpoint-lg) {
        font-size: 34px;
      }
    }
    & > :nth-child(5) {
      flex: 0 0 33%;
      margin-left: 32%;
      text-align: center;
      height: 38%;
      font-size: 13px;
      padding-top: 5px;
      @media (min-width: $breakpoint-sm) {
        font-size: 20px;
        flex: 0 0 25%;
        padding-top: 10px;
      }
      @media (min-width: $breakpoint-lg) {
        padding-top: 29px;
        font-size: 22px;
        flex: 0 0 23%;
      }
    }
  }
  .orbs {
    position: absolute;
    width: 100%;
    height: 100%;
    :nth-child(1) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;
      right: 10.1%;
      bottom: 4.7%;

      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.62%, #6e49cb 89.27%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        right: 0;
        left: 76.2%;
        bottom: 3.8%;
      }
    }
    :nth-child(2) {
      display: none;
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;
      right: 0.6%;
      bottom: 21.6%;
      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.62%, #6e49cb 89.27%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        display: block;
      }
    }
    :nth-child(3) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;
      right: 18.6%;
      bottom: 40.9%;

      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.62%, #ca4efb 89.27%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        right: 29.3%;
        bottom: 40%;
      }
    }
    :nth-child(4) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;

      right: 11.4%;
      top: 20.8%;
      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.56%, #ca4efb 89.21%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        right: 24.1%;
        top: 21%;
      }
    }
    :nth-child(5) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;
      right: -0.5%;
      top: 2%;
      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.62%, #ca4efb 89.27%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        right: 14.7%;
        top: 2%;
      }
    }
    :nth-child(6) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;

      left: 23.1%;
      top: 63.3%;
      border-radius: 50%;
      background: linear-gradient(70.97deg, #3825ff 10.6%, #ca4efb 89.25%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        left: 25.5%;
        top: 63.8%;
      }
    }
    :nth-child(7) {
      position: absolute;
      width: 0.8%;
      padding-bottom: 0.8%;
      left: 24.4%;
      top: 77.2%;
      border-radius: 50%;
      background: linear-gradient(70.97deg, #ca4efb 10.6%, #3825ff 89.25%);
      filter: drop-shadow(0px 0px 4px rgba(175, 145, 241, 0.75));
      @media (min-width: $breakpoint-md) {
        left: 26.2%;
        top: 77.5%;
      }
    }
  }
}

@keyframes dash {
  to {
    stroke-dashoffset: 0;
  }
}
</style>
